/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFPDFt@Č

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: AppendPages.exe in-pdf-file out-pdf-file append-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);		//PDF
		PtlParamOutput output(argv[2]);		//oPDF
		PtlParamInput appendfile(argv[3]);	//ǉPDF

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		//y[WRei̎擾
		PtlPages& pages = doc.getPages();

		PtlPDFDocument doc_app;

		// ǉPDFt@C[h܂B
		doc_app.load(appendfile);

		// y[W̒ǉ(1PڂS) OPTION_COPY_OUTLINES = 0x00000004 /* y[W}ɂ킹ĂRs[܂BPDF̃y[W}ɗLƂȂ܂B */
		pages.append(doc_app, 0, PtlPages::PAGE_ALL, PtlPages::OPTION_COPY_OUTLINES);

		// ʂ̃t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

