/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXg̑}

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void appendWatermark(PtlPDFDocument& doc);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: AppendTextWatermark.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// ̐ݒ
		appendWatermark(doc);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void appendWatermark(PtlPDFDocument& doc)
{
	PtlParamWaterMarkText watermarktext;

	//̖O̐ݒ
	watermarktext.setName("̖O");

	//zu`̐ݒ
	watermarktext.setRect(PtlRect(10.0f, 10.0f, 150.0f, 150.0f));

	//̔zu̐ݒ ALIGN_BOTTOM_LEFT = 7 /*  */
	watermarktext.setAlign(PtlParamWaterMark::ALIGN_BOTTOM_LEFT);

	//ZI[_[̐ݒ ZORDER_FRONT /* O */
	watermarktext.setZorder(PtlParamWaterMark::ZORDER_FRONT);

	//y[W͈̔͂̐ݒ PAGE_RANGE_ALL = 0 /* Sy[W */
	watermarktext.setPageRange(PtlParamWaterMark::PAGE_RANGE_ALL);

	//̕sx̐ݒ
	watermarktext.setOpacity(1.0f);

	//^COĔzu邩ǂ̐ݒ
	watermarktext.setTiling(false);

	//Ɏw肷镶̐ݒ
	PtlParamString strbuf("PDFToolAPI TextWatermark");
	watermarktext.setString(strbuf);

	//Ɏw肷tHg̐ݒ
	watermarktext.setFont(PtlParamFont("Times New Roman", 180.0f, PtlParamFont::WEIGHT_NORMAL, false, true));

	//̕Ɏw肷F̐ݒ
	watermarktext.setTextColor(PtlColorDeviceRGB(1.0f, 0.0f, 0.0f));

	//̉̕Ɏw肷F̐ݒ
	watermarktext.setOutlineColor(PtlColorDeviceRGB(0.0f, 1.0f, 0.0f));

	//̃eLXgΊpɔzuݒ
	watermarktext.setWriteDiagonal(false);

	//̃eLXgCӂ̊pxŔzuݒ
	watermarktext.setTextAngle(15.0f);

	//̐ݒ
	doc.appendWaterMark(watermarktext);

}
