/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFtH[̕`

	Copyright 2015-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void drawForm(PtlPage& page, const char* pathPdf);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: DrawForm.exe in-pdf-file out-pdf-file in-pdf-file2\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// tH[̕`
		drawForm(page, argv[3]);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void drawForm(PtlPage& page, const char* pathPdf)
{
	// y[WReg̎擾
	PtlContent& content = page.getContent();

	// ``
	PtlRect rect(0.0f, 0.0f, 100.0f, 100.0f);

	// }PDF
	PtlParamInput input2(pathPdf);

	PtlPDFDocument doc2;

	// PDFt@C[h܂B
	doc2.load(input2);

	// y[WRei̎擾
	PtlPages& pages2 = doc2.getPages();

	// 擪y[W̎擾
	PtlPage pageInsert = pages2.get(0);

	// tH[̕`
	content.drawForm(rect, PtlContent::ALIGN_CENTER, pageInsert);
}
