/*
Antenna House PDF Tool API V7.0
C++ Interface sample program

TvFeLXg{bNX

Copyright 2021 Antenna House, Inc.
*/

#include <PdfTk.h>

using namespace std;
using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc != 3)
	{
		printf("usage: DrawTextBox.exe in-pdf-file out-pdf-file \n");
		return 1;
	}

	try {
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument aDoc;
		aDoc.load(input);

		PtlOption option;
		option.setUnit(PtlOption::UNIT_PT);

		PtlPages& pages = aDoc.getPages();

		PtlPage page0 = pages.get(0);
		PtlSize pageSize = page0.getSize();

		// TextBoxޗ̈`̓y[WTCY㉺E20|Cĝɂ
		PtlRect rect(20, 20, pageSize.getWidth()-20, pageSize.getHeight()-20);

		PtlContent& content = page0.getContent();

		float fontSize = 12.0f;
		PtlParamString fontname = "lr SVbN";

		PtlParamFont fontNormal(fontname, fontSize, false, false, true);
		PtlParamFont fontBoldItalic(fontname, fontSize, true, true, true);

		PtlColorDeviceRGB colorBlack = PtlColorDeviceRGB(0.0f, 0.0f, 0.0f);
		PtlColorDeviceRGB colorRed = PtlColorDeviceRGB(1.0f, 0.0f, 0.0f);
		PtlColorDeviceRGB colorBlue = PtlColorDeviceRGB(0.0f, 0.0f, 1.0f);
		PtlColorDeviceRGB colorBack = PtlColorDeviceRGB(0.5f, 0.8f, 0.8f);
		PtlColorDeviceRGB colorBack2 = PtlColorDeviceRGB(0.8f, 0.5f, 0.8f);

		// rect300~400TextBoxɏ
		PtlTextBox& textBox = content.drawTextBox(rect, PtlContent::ALIGN_TOP_LEFT, 300, 400);

		// TextBox̉t
		textBox.setOutlineColor(colorRed);
		// 肪eLXg͂ރTCYɕς悤w
		textBox.fitToBBox(true);

		PtlParamWriteStringTextBox paramWriteString;
		paramWriteString.setFont(fontNormal);
		paramWriteString.setTextColor(colorBlack);

		const char*  text1("eLXg͐܂Ԃ܂BB");
		textBox.writeStringNL(PtlParamString(text1), paramWriteString);

		const char*  text2("p͓rŐ܂Ԃ܂BTextBoxPtlParamWriteStringTextBoxg܂B");
		textBox.writeStringNL(PtlParamString(text2), paramWriteString);

		textBox.writeNL();
		paramWriteString.setUnderline(true);
		paramWriteString.setStrikeOut(true);
		const char*  text3("ƎPtlParamWriteStringTextBoxŎw肵ďƂł܂B");
		textBox.writeString(PtlParamString(text3), paramWriteString);
		paramWriteString.setUnderline(false);
		paramWriteString.setStrikeOut(false);

		PtlParamWriteStringTextBox paramWriteStringBoldItalic;
		paramWriteStringBoldItalic.setFont(fontBoldItalic);
		const char*  text4("AΑ̂̃tHgX^CPtlParamFontŐݒ肵܂B");
		textBox.writeStringNL(PtlParamString(text4), paramWriteStringBoldItalic);

		textBox.writeNL();
		PtlParamWriteStringTextBox paramWriteStringColor;
		fontNormal.setFontSize(24);
		paramWriteStringColor.setFont(fontNormal);
		paramWriteStringColor.setTextColor(colorRed);
		paramWriteStringColor.setBackColor(colorBack);
		const char*  text41("tHgTCY24ɂĕ̐FĂ݂܂B");
		textBox.writeStringNL(PtlParamString(text41), paramWriteStringColor);
		paramWriteStringColor.setTextColor(colorBack);
		paramWriteStringColor.setOutlineColor(colorBlack);
		paramWriteStringColor.setBackColor(colorBack2);
		const char*  text42("̉̐FĂ݂܂B");
		textBox.writeStringNL(PtlParamString(text42), paramWriteStringColor);
		fontNormal.setFontSize(12);

		textBox.writeNL(12);	// ̂܂܉sƁA24ŉŝ12ɂ
		PtlParamWriteStringTextBox paramWriteString5;
		const char*  text52("t");
		paramWriteString5.setFont(fontNormal);
		paramWriteString5.setFormat(PtlParamWriteStringTextBox::FORM_SUP);
		paramWriteString5.setBackColor(colorBack2);
		paramWriteString5.setUnderline(true);
		paramWriteString5.setStrikeOut(true);
		textBox.writeString(PtlParamString(text52), paramWriteString5);
		const char*  text53("");
		paramWriteString5.setFormat(PtlParamWriteStringTextBox::FORM_NORMAL);
		paramWriteString5.setBackColor(colorBack);
		textBox.writeString(PtlParamString(text53), paramWriteString5);
		const char*  text54("tB");
		paramWriteString5.setBackColor(colorBack2);
		paramWriteString5.setFormat(PtlParamWriteStringTextBox::FORM_SUB);
		textBox.writeString(PtlParamString(text54), paramWriteString5);
		const char*  text55("ʏ핶B");
		paramWriteString5.setFormat(PtlParamWriteStringTextBox::FORM_NORMAL);
		paramWriteString5.setBackColor(colorBack);
		textBox.writeString(PtlParamString(text55), paramWriteString5);

		const char*  text6("sԂLďĂ݂܂B");
		PtlParamWriteStringTextBox paramWriteString6;
		paramWriteString6.setFont(fontNormal);
		paramWriteString6.setBackColor(colorBack2);
		paramWriteString6.setLineSpacing(1.5);
		textBox.writeStringNL(PtlParamString(text6), paramWriteString6);

		textBox.writeNL();
		const char*  text7("ԊuĂ݂܂B");
		PtlParamWriteStringTextBox paramWriteString7;
		paramWriteString7.setFont(fontNormal);
		paramWriteString7.setBackColor(colorBack);
		textBox.writeStringNL(PtlParamString(text7), paramWriteString7);
		const char*  text72("Ԋu(-1)B");
		paramWriteString7.setCharSpacing(-1);
		textBox.writeStringNL(PtlParamString(text72), paramWriteString7);
		const char*  text73("ԊuL(1)B");
		paramWriteString7.setCharSpacing(1);
		textBox.writeStringNL(PtlParamString(text73), paramWriteString7);
		const char*  text74("ԊuL(2)B");
		paramWriteString7.setCharSpacing(2);
		paramWriteString7.setUnderline(true);
		paramWriteString7.setStrikeOut(true);
		textBox.writeStringNL(PtlParamString(text74), paramWriteString7);

		textBox.writeNL();
		PtlParamWriteStringTextBox paramWriteString8;
		paramWriteString8.setFont(fontNormal);
		const char*  text8("wtƉtgďĂ݂܂B");
		textBox.writeStringNL(PtlParamString(text8), paramWriteString8);
		PtlParamWriteStringTextBox paramWriteString8Sup;
		paramWriteString8Sup.setFont(fontNormal);
		paramWriteString8Sup.setFormat(PtlParamWriteStringTextBox::FORM_SUP);
		PtlParamWriteStringTextBox paramWriteString8Sub;
		paramWriteString8Sub.setFont(fontNormal);
		paramWriteString8Sub.setFormat(PtlParamWriteStringTextBox::FORM_SUB);

		// C4H8O2
		const char*  C4H8O2_C("C");
		textBox.writeString(PtlParamString(C4H8O2_C), paramWriteString8);
		const char*  C4H8O2_4("4");
		textBox.writeString(PtlParamString(C4H8O2_4), paramWriteString8Sub);
		const char*  C4H8O2_H("H");
		textBox.writeString(PtlParamString(C4H8O2_H), paramWriteString8);
		const char*  C4H8O2_8("8");
		textBox.writeString(PtlParamString(C4H8O2_8), paramWriteString8Sub);
		const char*  C4H8O2_O("O");
		textBox.writeString(PtlParamString(C4H8O2_C), paramWriteString8);
		const char*  C4H8O2_2("2");
		textBox.writeStringNL(PtlParamString(C4H8O2_2), paramWriteString8Sub);
		// SO42-
		const char*  SO42__SO("SO");
		textBox.writeString(PtlParamString(SO42__SO), paramWriteString8);
		const char*  SO42__4("4");
		textBox.writeString(PtlParamString(SO42__4), paramWriteString8Sub);
		const char*  SO42__2_("2-");
		textBox.writeString(PtlParamString(SO42__2_), paramWriteString8Sup);

		textBox.terminate();

		aDoc.save(output);

		printf("--  --\n");

	} catch (PtlException e) {
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());

	} catch (...) {
		printf("Exception\n");
	}
}