﻿/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	概要：フォームデータのXFDFへのエクスポート

	Copyright 2021 Antenna House,Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;
using namespace std;

int main(int argc, char* argv[])
{
	if (argc != 3)
	{
		printf("usage: ExportFormDataXFDF.exe in-pdf-file out-xfdf-file \n");
		return 1;
	}
	try {
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument doc;
		// PDFファイルをロードします。
		doc.load(input);

		doc.exportFormFieldsToXFDF(output);		//フォームフィールドデータのXFDF文書へのエクスポート
		printf("-- 完了 --\n");
	}
	catch (const PtlException& e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
}
