/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXgo

	Copyright 2018 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void extractText(PtlPage& page);

int main(int argc, char* argv[])
{
	if (argc < 2) {
		printf("usage: ExtractText.exe in-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// eLXgo
		extractText(page);

		printf("\n!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void extractText(PtlPage& page)
{
	// y[WTCY
	PtlSize pageSize = page.getSize();

	// y[WReg̎擾
	PtlContent& content = page.getContent();

	// eLXgop[^
	PtlParamExtractText paramExtractText;

	// eLXgo͈
	PtlRect rect(0.0f, 0.0f, pageSize.getWidth()/2, pageSize.getHeight()/2);
	//paramExtractText.appendRect(rect);	// ̍s̃RgOƋ`̈̃eLXg𒊏o

	// eLXgo
	PtlParamString text = content.extractText(paramExtractText);

	printf(text.c_str());
}
