/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFYtt@C̏o

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: OutputEmbeddedFile.exe in-pdf-file write-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamString writefilename(argv[2]);
		PtlPDFDocument doc;

		// PDFtB[h܂B
		doc.load(input);

		// Ytt@CRei̎擾
		PtlEmbeddedFiles& embeddedfiles = doc.getEmbeddedFiles();

		// Ytt@CRei󂩂ǂ
		if (embeddedfiles.isEmpty()){
			printf("Ytt@CRei\n");
			return 1;
		}

		// Ytt@C̎擾
		printf("Ytt@C : %d\n", embeddedfiles.getCount());

		// PԖڂ̓Ytt@C̎擾
		PtlEmbeddedFile embeddedfile = embeddedfiles.get(0);
		printf("PԖڂ̓Ytt@C : %s\n", embeddedfile.getFileName().c_str());

		// PԖڂ̓Ytt@C̏o
		printf("PԖڂ̓Ytt@C̏o...\n");
		PtlParamOutput outputEmbed(writefilename);
		embeddedfile.writeFile(outputEmbed);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
