/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF̍폜

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: RemoveWaterMark.exe in-pdf-file out-pdf-file watermark-name\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlParamString watermarkname(argv[3]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// ̍폜FsetNameŐݒ肵Oɂ
		doc.removeWaterMark(watermarkname);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

